from crypto import PasswordHasher
from model import Session, User
from exceptions import InvalidCredentialsError, UserExistsError


class UserOps:
    def __init__(self, username, password):
        self.username = username
        self.password = password

    def authenticate(self):
        with Session() as db:

            user = db.query(User).filter(User.username == self.username).first()

            if not user or not PasswordHasher.verify(self.password, user.passwordhash):
                raise InvalidCredentialsError

    def register(self):
        with Session() as db:

            if db.query(User).filter(User.username == self.username).all():
                raise UserExistsError

            user = User(username=self.username,
                        passwordhash=PasswordHasher.hash(self.password))
            db.add(user)
            db.commit()
